#include "redica.h"
#include <bits/stdc++.h>
using namespace std;
void gen(vector<int> v,int n,int k,int s,int needsize)
{
    for(int i=1;i<=min(1,s-(n-1)*k);i++)
    {
        v.push_back(i);
        if(v.size()==needsize) submit(v);
        else gen(v,n-1,k,s-i,needsize);
        v.pop_back();
    }
}
bool pow(int n,int k)
{
    int num=1;
    for(int i=1;i<=k;i++)
    {
        num*=n;
        if(num>6e8) return 0;
    }
    return 1;
}
void solve(int N, int K, int S)
{
    int need=S;
    vector<int> v;
    int rem=N;
    while(1)
    {
        if(pow(K,rem))
        {
            gen(v,rem,K,need,N);
        }
        int x=query();
        v.push_back(x);
        need-=x;
        rem--;
    }
}
